<template>
    <Spinner v-if="loading"></Spinner>
    <template v-else>
        <VTable v-model:currentPage="currentPage" :data="computedData" :filters="filter" sortHeaderClass="flex items-center"
            class="w-full text-md text-left text-gray-500 dark:text-gray-300 border-t" :pageSize="10"
            @stateChanged="tableState = $event" @totalPagesChanged="totalPages = $event">
            <template #head class="text-xs text-gray-700 uppercase bg-gray-50 dark:bg-gray-700 dark:text-gray-400">
                <tr class="border-b">
                    <VTh sortKey="name" defaultSort="desc" class="px-6 py-3">Name</VTh>
                    <VTh sortKey="version" defaultSort="desc" class="px-6 py-3">Version</VTh>
                    <VTh sortKey="vendor" class="px-6 py-3">Vendor</VTh>
                    <VTh sortKey="moduleKey" class="px-6 py-3">Key</VTh>
                    <VTh sortKey="uploadedAt" class="px-6 py-3">Uploaded</VTh>
                    <td></td>
                </tr>
            </template>
            <template #body="{ rows }">
                <tr v-for="row in rows" :key="row.id"
                    class="border-b dark:bg-gray-800 dark:border-gray-700 hover:bg-gray-700 hover:cursor-pointer">
                    <td class="px-6 py-2 font-medium text-gray-900 dark:text-white whitespace-nowrap">
                        {{ row.name }}
                    </td>
                    <td class="px-6 py-2">
                        {{ row.version }}
                    </td>
                    <td class="px-6 py-2">
                        {{ row.vendor }}
                    </td>
                    <td class="px-6 py-2">
                        {{ row.moduleKey }}
                    </td>
                    <td class="px-6 py-2">
                        {{ datetimeFilter(row.uploadedAt) }}
                    </td>
                    <td class="px-0 py-2 flex items-center">
                        <div @click="deleteModule(row._id)" role="link"
                            class="flex items-center hover:bg-red-600 bg-red-700 mr-4 px-4 py-2 rounded">
                            <svg style="width: 24px; height: 24px" viewBox="0 0 24 24">
                                <path fill="currentColor"
                                    d="M19,4H15.5L14.5,3H9.5L8.5,4H5V6H19M6,19A2,2 0 0,0 8,21H16A2,2 0 0,0 18,19V7H6V19Z" />
                            </svg>
                        </div>
                        <div @click="downloadModule(row._id)" role="link"
                            class="flex items-center hover:bg-blue-600 bg-blue-700 mr-4 px-4 py-2 rounded">
                            <svg style="width: 24px; height: 24px" viewBox="0 0 24 24">
                                <path fill="currentColor" d="M5,20H19V18H5M19,9H15V3H9V9H5L12,16L19,9Z" />
                            </svg>
                        </div>
                    </td>
                </tr>
            </template>
        </VTable>
        <VTPagination v-model:currentPage="currentPage" :totalPages="totalPages" :boundaryLinks="true" v-if="totalPages > 1"
            class="w-full text-gray-700 mt-2 flex justify-center" />
    </template>
</template>

<style>
ul.pagination {
    display: flex;
    align-items: center;
}

ul.pagination>li {
    margin-right: 2px;
}
</style>

<script lang="ts" setup>
import axios from "axios";
import { computed, ref } from "vue";

const props = defineProps(["tableData", "loading"]);
const computedData = computed(() => props.tableData ?? []);

const currentPage = ref(1);
const totalPages = ref(0);

const filter = ref({
    default: {
        value: "",
        keys: ["environmentId", "id"],
    },
});

const datetimeFilter = function (value: string): string {
    if (typeof value === "undefined") return "";

    const firstSplit = value.split("T");
    const secondSplit = firstSplit[1].split(".");
    return `${firstSplit[0]} ${secondSplit[0]}`;
};

const deleteModule = async function (id: string) {
    await axios.delete(`${window.origin}/api/modules/${id}`);
};

const downloadModule = function (id: string) {
    const link = document.createElement("a");
    link.href = `${window.origin}/api/modules/${id}/download`;
    link.setAttribute("download", "test");
    link.setAttribute("target", "_blank");
    document.body.appendChild(link);
    link.click();
};

const tableState = ref();
</script>
